## pktools 2.6.7

=== CMakeLists.txt ===
###############################################################################
#
# CMake build scripts for PKTOOLS
# 
#
# History
# 2010/12/14 - Created by Peter Bunting for SPDLib
# 2012/02/07 - Edited by Peter Bunting for PKTOOLS
# 2014/11/22 - Edited by Peter Bunting for pktools
# 2015/12/10 - Edited by Pieter Kempeneers and Kris Vanhoof
# Change log
# Find package lib
# Boost: disable auto linking: add_definitions("-DBOOST_ALL_NO_LIB")
# add cmake env variable Boost_COMPILER -vc110
# FANN: create library CMake: add ADD_DEFINITIONS(-DFANN_DLL_EXPORTS)
# GDAL: disabled macro for Visual Studio 2015
#if defined(_MSC_VER) && (_MSC_VER < 1900)
#  define snprintf _snprintf
#endif
#set CMAKE_INSTALL_PREFIX to C:/OSGeo4W64;C:/Users/kempenep/Downloads/FANN-2.2.0-Source/FANN-2.2.0-Source/install;C:/Users/kempenep/Downloads/armadillo-6.200.4/install;C:\Users\kempenep\Downloads\nlopt-2.4.2-dll64
#
###############################################################################
cmake_minimum_required(VERSION 2.6.0)
#cmake_minimum_required(VERSION 2.8)
###############################################################################
# Set Project name and version
project (PKTOOLS)

set (PROJECT_BINARY_DIR bin)
set (PROJECT_LIBRARY_DIR lib)
set (PROJECT_INCLUDE_DIR include/pktools)
set (PROJECT_DOC_DIR doc)
set (PROJECT_SOURCE_DIR src)

# The version number.
set (PKTOOLS_VERSION_MAJOR 2)
set (PKTOOLS_VERSION_MINOR 6)
set (PKTOOLS_VERSION_PATCH 7)
set (PKTOOLS_VERSION "${PKTOOLS_VERSION_MAJOR}.${PKTOOLS_VERSION_MINOR}.${PKTOOLS_VERSION_PATCH}")
set (PKTOOLS_PACKAGE_VERSION "${PKTOOLS_VERSION_MAJOR}.${PKTOOLS_VERSION_MINOR}.${PKTOOLS_VERSION_PATCH}")
set (PKTOOLS_PACKAGE_STRING "PKTOOLS ${PKTOOLS_VERSION_MAJOR}.${PKTOOLS_VERSION_MINOR}.${PKTOOLS_VERSION_PATCH}")
set (PKTOOLS_PACKAGE_BUGREPORT "kempenep@gmail.com")
set (PKTOOLS_PACKAGE "pktools")
set (PKTOOLS_COPYRIGHT_YEAR 2016)

set (PKTOOLS_ALGORITHMS_VERSION_MAJOR 1)
set (PKTOOLS_ALGORITHMS_VERSION_MINOR 6)
set (PKTOOLS_ALGORITHMS_VERSION_PATCH 0)
set (PKTOOLS_ALGORITHMS_VERSION "${PKTOOLS_ALGORITHMS_VERSION_MAJOR}.${PKTOOLS_ALGORITHMS_VERSION_MINOR}.${PKTOOLS_ALGORITHMS_VERSION_PATCH}")

set (PKTOOLS_FILECLASSES_VERSION_MAJOR 1)
set (PKTOOLS_FILECLASSES_VERSION_MINOR 6)
set (PKTOOLS_FILECLASSES_VERSION_PATCH 0)
set (PKTOOLS_FILECLASSES_VERSION "${PKTOOLS_FILECLASSES_VERSION_MAJOR}.${PKTOOLS_FILECLASSES_VERSION_MINOR}.${PKTOOLS_FILECLASSES_VERSION_PATCH}")

set (PKTOOLS_IMAGECLASSES_VERSION_MAJOR 1)
set (PKTOOLS_IMAGECLASSES_VERSION_MINOR 6)
set (PKTOOLS_IMAGECLASSES_VERSION_PATCH 0)
set (PKTOOLS_IMAGECLASSES_VERSION "${PKTOOLS_IMAGECLASSES_VERSION_MAJOR}.${PKTOOLS_IMAGECLASSES_VERSION_MINOR}.${PKTOOLS_IMAGECLASSES_VERSION_PATCH}")

set (PKTOOLS_LASCLASSES_VERSION_MAJOR 1)
set (PKTOOLS_LASCLASSES_VERSION_MINOR 6)
set (PKTOOLS_LASCLASSES_VERSION_PATCH 0)
set (PKTOOLS_LASCLASSES_VERSION "${PKTOOLS_LASCLASSES_VERSION_MAJOR}.${PKTOOLS_LASCLASSES_VERSION_MINOR}.${PKTOOLS_LASCLASSES_VERSION_PATCH}")

# Name of C++ library
set(PKTOOLS_BASE_LIB_NAME base)
set(PKTOOLS_ALGORITHMS_LIB_NAME algorithms)
set(PKTOOLS_FILECLASSES_LIB_NAME fileClasses)
set(PKTOOLS_IMAGECLASSES_LIB_NAME imageClasses)
set(PKTOOLS_LASCLASSES_LIB_NAME lasClasses)

option (BUILD_SHARED_LIBS "Build with shared library" OFF)
set(BUILD_WITH_LIBLAS FALSE CACHE BOOL "Choose if pktools is to be built with liblas")
set(BUILD_WITH_FANN FALSE CACHE BOOL "Choose if pktools is to be built with fann")
#set(BUILD_WITH_NLOPT FALSE CACHE BOOL "Choose if pktools is to be built with nlopt")
set(PKTOOLS_WITH_UTILITIES TRUE CACHE BOOL "Choose if pktools utilities should be built")

set(GSL_INCLUDE_DIR /usr/include CACHE PATH "Include PATH for GSL")
set(GSL_LIB_PATH /usr/lib CACHE PATH "Library PATH for GSL")

###############################################################################

###############################################################################
# CMake settings
# cmake_minimum_required(VERSION 2.6.0)

IF(NOT CMAKE_BUILD_TYPE)
  #SET(CMAKE_BUILD_TYPE "DEBUG")
  SET(CMAKE_BUILD_TYPE "RELEASE")
  #SET(CMAKE_BUILD_TYPE "RELWITHDEBINFO")
  #SET(CMAKE_BUILD_TYPE "MINSIZEREL")
ENDIF()

set(CMAKE_COLOR_MAKEFILE ON)

# Allow advanced users to generate Makefiles printing detailed commands
mark_as_advanced(CMAKE_VERBOSE_MAKEFILE)

# Path to additional CMake modules
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
###############################################################################

###############################################################################
# Setup configure file
configure_file ( "cmake-config.h.in" "${CMAKE_CURRENT_BINARY_DIR}/base/config.h" @ONLY)
include_directories("${CMAKE_CURRENT_BINARY_DIR}/base")
add_definitions(-DHAVE_CONFIG_H)
###############################################################################

###############################################################################
# Documentation
#file(READ "doc/index.txt" README )
file(WRITE "README.txt" "${README}")
###############################################################################

###############################################################################
# Platform and compiler specific settings

if(WIN32)
    if (MSVC)
        if (MSVC80 OR MSVC90 OR MSVC10)
            add_definitions(-D_CRT_SECURE_NO_DEPRECATE)
            add_definitions(-D_CRT_SECURE_NO_WARNINGS)
            add_definitions(-D_CRT_NONSTDC_NO_WARNING)
            add_definitions(-D_SCL_SECURE_NO_WARNINGS)
        endif()
        
        if(CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
            string(REGEX REPLACE "/W[0-4]" "/W4"
                   CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
        else()
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
        endif()

        # Generate dot-user file with user-specific settings for Visual Studio project
        set(MSVC_ENVIRONMENT_PATH "" CACHE STRING
            "Custom PATH for Environment property in Visual Studio project configuration")
        mark_as_advanced(MSVC_ENVIRONMENT_PATH)
        set(VCPROJ_USER_ENVIRONMENT_PATH_DEBUG "${ENVIRONMENT_PATH}")
        mark_as_advanced(VCPROJ_USER_ENVIRONMENT_PATH_DEBUG)

    endif()

	set(CMAKE_INCLUDE_PATH c:/osgeo4w/include;$ENV{CMAKE_INCLUDE_PATH})
    set(CMAKE_LIBRARY_PATH c:/osgeo4w/lib;$ENV{CMAKE_LIBRARY_PATH})
else()
  # Recommended C++ compilation flags
  # -Weffc++
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -pg")
  set(PKTOOLS_COMMON_CXX_FLAGS
    "-Wall -Wpointer-arith -Wcast-align -Wcast-qual -Wredundant-decls -Wno-long-long")

  if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)

    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC ${PKTOOLS_COMMON_CXX_FLAGS}")
    if (CMAKE_COMPILER_IS_GNUCXX)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++98")
    endif()

  elseif("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang" OR "${CMAKE_CXX_COMPILER}" MATCHES "clang")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${PKTOOLS_COMMON_CXX_FLAGS}")
  endif()
endif(WIN32)

if (APPLE)
  set(SO_EXT dylib)
 # set(CMAKE_FIND_FRAMEWORK "LAST")
elseif(WIN32)
  set(SO_EXT dll)
else()
  set(SO_EXT so)
endif(APPLE)
###############################################################################

###############################################################################
# Check the required libraries are present

#include_directories(${GDAL_INCLUDE_DIR})
#if (MSVC)
#  set(GDAL_LIBRARIES -LIBPATH:${GDAL_LIB_PATH} gdal_i.lib)
#else()
#  set(GDAL_LIBRARIES -L${GDAL_LIB_PATH} -lgdal)
#endif(MSVC)

find_package(GDAL 1.10 REQUIRED)
if(GDAL_FOUND)
	include_directories(${GDAL_INCLUDE_DIRS})
endif()

find_package(GSL REQUIRED)
if(GSL_FOUND)
  include_directories(${GSL_INCLUDE_DIRS})
  add_definitions(-DGSL_DLL)
endif()

find_package(Armadillo REQUIRED)
if(ARMADILLO_FOUND)
	include_directories(${ARMADILLO_INCLUDE_DIRS})
endif()

if (BUILD_WITH_LIBLAS)
	find_package(LIBLAS)
	if(LIBLAS_FOUND)
	  include_directories(${LIBLAS_INCLUDE_DIRS})
	endif()
	set(Boost_DEBUG 0)
	find_package(Boost COMPONENTS filesystem system)
	if(Boost_FOUND)
		include_directories(${Boost_INCLUDE_DIRS})
		add_definitions("-DBOOST_ALL_NO_LIB")
	endif()
	
#	include_directories(${BOOST_INCLUDE_DIR})
#	if (MSVC)
#		set(BOOST_LIBRARIES -LIBPATH:${BOOST_LIB_PATH} libboost_filesystem-vc100-mt-1_56.lib libboost_system-vc100-mt-1_56.lib)
#	else()
#		set(BOOST_LIBRARIES -L${BOOST_LIB_PATH} -lboost_filesystem -lboost_system)
#	endif(MSVC)
endif(BUILD_WITH_LIBLAS)

if (BUILD_WITH_FANN)
	find_package(FANN)
	if(FANN_FOUND)
		include_directories(${FANN_INCLUDE_DIRS})
		add_definitions(-DFANN_DLL)
	endif()
endif(BUILD_WITH_FANN)

# if (BUILD_WITH_NLOPT)
#   find_package(NLOPT)
#   if(NLOPT_FOUND)
#     include_directories(${NLOPT_INCLUDE_DIRS})
#     add_definitions(-DNLOPT_DLL)
#   endif()
# endif(BUILD_WITH_NLOPT)
###############################################################################

###############################################################################
# Build libraries
include_directories("${PROJECT_SOURCE_DIR}")
add_subdirectory ("${PROJECT_SOURCE_DIR}")
###############################################################################

###############################################################################
# Build executables

#configure_file ( "cmake-config.in" "${PROJECT_BINARY_DIR}/pktools-config" @ONLY )
#test
configure_file ( "cmake-config.in" "${CMAKE_CURRENT_BINARY_DIR}/pktools-config" @ONLY )
configure_file ( "cmake.pc.in" "pktools.pc"  @ONLY)


set_property(GLOBAL PROPERTY USE_FOLDERS ON)

set(PKLIBS ${PKTOOLS_BASE_LIB_NAME} ${PKTOOLS_IMAGECLASSES_LIB_NAME} ${PKTOOLS_FILECLASSES_LIB_NAME} ${PKTOOLS_ALGORITHMS_LIB_NAME} ${GDAL_LIBRARIES} ${GSL_LIBRARIES} ${ARMADILLO_LIBRARIES} ${Boost_LIBRARIES})

set(PKUTILITIES
  pkinfo
  pkcrop
  pkdiff
  pkgetmask
  pksetmask
  pkcreatect 
  pkdumpimg 
  pkdumpogr 
  pksieve 
  pkstat
  pkstatascii 
  pkstatogr 
  pkstatprofile
  pkegcs 
  pkextractimg
  pkextractogr
  pkfillnodata 
  pkfilter 
  pkfilterdem 
  pkfilterascii 
  pkdsm2shadow 
  pkcomposite
  pkpolygonize 
  pkascii2img 
  pksvm 
  pkfssvm 
  pkoptsvm
  pkascii2ogr 
  pkreclass 
  pkkalman
  )

set(PKFANNUTILITIES
	pkann
	pkfsann
	pkregann
)

# set(PKNLOPTUTILITIES
# 	pkoptsvm
# )

if (PKTOOLS_WITH_UTILITIES)
	foreach(UTILITY ${PKUTILITIES})
    		add_executable(${UTILITY} src/apps/${UTILITY}.cc)
    		target_link_libraries(${UTILITY} ${PKLIBS})
    		set_target_properties(${UTILITY} PROPERTIES FOLDER utilities)
	endforeach()

	if (BUILD_WITH_LIBLAS)
		set(PKLIBS ${PKLIBS} ${PKTOOLS_LASCLASSES_LIB_NAME})
		foreach(PKLASUTILITY ${PKLASUTILITIES})
		add_executable(${PKLASUTILITY} src/apps/${PKLASUTILITY}.cc)
		target_link_libraries (${PKLASUTILITY} 
		${PKLIBS} ${LIBLAS_LIBRARIES})
    		set_target_properties(${PKLASUTILITY} PROPERTIES FOLDER utilities)
		endforeach()
	endif()
	if (BUILD_WITH_FANN)
		set(PKLIBS ${PKLIBS} ${FANN_LIBRARIES})
		foreach(PKFANNUTILITY ${PKFANNUTILITIES})
		add_executable(${PKFANNUTILITY} src/apps/${PKFANNUTILITY}.cc)
		message(${PKLIBS})
		target_link_libraries (${PKFANNUTILITY} ${PKLIBS})
    		set_target_properties(${PKFANNUTILITY} PROPERTIES FOLDER utilities)
		endforeach()
	endif()
	# if (BUILD_WITH_NLOPT)
	# 	set(PKLIBS ${PKLIBS} ${NLOPT_LIBRARIES})
	# 	foreach(PKNLOPTUTILITY ${PKNLOPTUTILITIES})
	# 	add_executable(${PKNLOPTUTILITY} src/apps/${PKNLOPTUTILITY}.cc)
	# 	message(${PKLIBS})
	# 	target_link_libraries (${PKNLOPTUTILITY} ${PKLIBS})
    	# 	set_target_properties(${PKNLOPTUTILITY} PROPERTIES FOLDER utilities)
	# 	endforeach()
	# endif()	
	# add_custom_target(utilities DEPENDS ${PKUTILITIES} ${PKLASUTILITIES} ${PKFANNUTILITIES} ${PKNLOPTUTILITIES})
	add_custom_target(utilities DEPENDS ${PKUTILITIES} ${PKLASUTILITIES} ${PKFANNUTILITIES})
	set_target_properties(utilities PROPERTIES FOLDER 
	phony)

endif()


	
###############################################################################

=== src/CMakeLists.txt ===
###############################################################################
# set file locations
set(BASE_SRC_DIR base)
set(ALGOR_SRC_DIR algorithms)
set(FILECLASS_SRC_DIR fileclasses)
set(IMGCLASS_SRC_DIR imageclasses)
set(LASCLASS_SRC_DIR lasclasses)

set(BASE_H
	${BASE_SRC_DIR}/IndexValue.h
	${BASE_SRC_DIR}/Optionpk.h
	${BASE_SRC_DIR}/PosValue.h
	${BASE_SRC_DIR}/Vector2d.h
	${BASE_SRC_DIR}/Vector2d.cc
#	${BASE_SRC_DIR}/config.h
	)

set(ALGOR_H
	${ALGOR_SRC_DIR}/ConfusionMatrix.h
	${ALGOR_SRC_DIR}/CostFactory.h
	${ALGOR_SRC_DIR}/CostFactorySVM.h
	${ALGOR_SRC_DIR}/Egcs.h
	${ALGOR_SRC_DIR}/FeatureSelector.h
	${ALGOR_SRC_DIR}/Filter.h
	${ALGOR_SRC_DIR}/Filter2d.h
	${ALGOR_SRC_DIR}/ImgRegression.h
	${ALGOR_SRC_DIR}/StatFactory.h
	${ALGOR_SRC_DIR}/myfann_cpp.h
	${ALGOR_SRC_DIR}/svm.h
#	${ALGOR_SRC_DIR}/OptFactory.h
	)

set(ALGOR_CC
	${ALGOR_SRC_DIR}/ConfusionMatrix.cc
	${ALGOR_SRC_DIR}/CostFactorySVM.cc
	${ALGOR_SRC_DIR}/CostFactorySVM.h
	${ALGOR_SRC_DIR}/Egcs.cc
	${ALGOR_SRC_DIR}/Filter.cc
	${ALGOR_SRC_DIR}/Filter2d.cc
	${ALGOR_SRC_DIR}/ImgRegression.cc
	${ALGOR_SRC_DIR}/svm.cpp
	)
	
set(FILECLASS_H
	${FILECLASS_SRC_DIR}/FileReaderAscii.h 
	)

set(FILECLASS_CC
	${FILECLASS_SRC_DIR}/FileReaderAscii.cc 
	)
	
set(IMGCLASS_H
	${IMGCLASS_SRC_DIR}/ImgRasterGdal.h 
	${IMGCLASS_SRC_DIR}/ImgReaderGdal.h 
	${IMGCLASS_SRC_DIR}/ImgReaderOgr.h 
	${IMGCLASS_SRC_DIR}/ImgWriterGdal.h 
	${IMGCLASS_SRC_DIR}/ImgWriterOgr.h 
	${IMGCLASS_SRC_DIR}/ImgUpdaterGdal.h 
	)

set(IMGCLASS_CC
	${IMGCLASS_SRC_DIR}/ImgRasterGdal.cc
	${IMGCLASS_SRC_DIR}/ImgReaderGdal.cc
	${IMGCLASS_SRC_DIR}/ImgReaderOgr.cc
	${IMGCLASS_SRC_DIR}/ImgWriterGdal.cc 
	${IMGCLASS_SRC_DIR}/ImgWriterOgr.cc
	${IMGCLASS_SRC_DIR}/ImgUpdaterGdal.cc 
	)
	
set(LASCLASS_H
	${LASCLASS_SRC_DIR}/FileReaderLas.h 
	)

set(LASCLASS_CC
	${LASCLASS_SRC_DIR}/FileReaderLas.cc 
	)

###############################################################################

###############################################################################
# Group source files for IDE source explorers
source_group("CMake Files" FILES CMakeLists.txt)
source_group("src_base" FILES ${BASE_H})
source_group("src_algor" FILES ${ALGOR_H} ${ALGOR_CC})
source_group("src_fileclass" FILES ${FILECLASS_H} ${FILECLASS_CC})
source_group("src_imgclass" FILES ${IMGCLASS_H} ${IMGCLASS_CC})
source_group("src_lasclass" FILES ${LASCLASS_H} ${LASCLASS_CC})
###############################################################################

###############################################################################
# Build and link library

add_library( ${PKTOOLS_BASE_LIB_NAME} ${BASE_H} )
target_link_libraries(${PKTOOLS_BASE_LIB_NAME} ${GDAL_LIBRARIES} ${GSL_LIBRARIES} ${ARMADILLO_LIBRARIES} )

add_library( ${PKTOOLS_IMAGECLASSES_LIB_NAME} ${IMGCLASS_H} ${IMGCLASS_CC} ${BASE_H} )
target_link_libraries(${PKTOOLS_IMAGECLASSES_LIB_NAME} ${GDAL_LIBRARIES} ${GSL_LIBRARIES} ${ARMADILLO_LIBRARIES} )
# foreach(lib ${GSL_LIBRARIES})
# message(${lib})
# endforeach()
add_library( ${PKTOOLS_ALGORITHMS_LIB_NAME} ${ALGOR_H} ${ALGOR_CC} ${BASE_H} )
target_link_libraries(${PKTOOLS_ALGORITHMS_LIB_NAME} ${GDAL_LIBRARIES} ${GSL_LIBRARIES} ${ARMADILLO_LIBRARIES} ${PKTOOLS_IMAGECLASSES_LIB_NAME} )

add_library( ${PKTOOLS_FILECLASSES_LIB_NAME} ${FILECLASS_H} ${FILECLASS_CC} ${BASE_H} )
target_link_libraries(${PKTOOLS_FILECLASSES_LIB_NAME} ${GDAL_LIBRARIES} ${GSL_LIBRARIES} ${ARMADILLO_LIBRARIES} )

if (BUILD_WITH_LIBLAS)
	add_library( ${PKTOOLS_LASCLASSES_LIB_NAME} ${LASCLASS_H} ${LASCLASS_CC} ${BASE_H} )
	target_link_libraries(${PKTOOLS_FILECLASSES_LIB_NAME} ${LIBLAS_LIBRARIES} ${BOOST_LIBRARIES} ${GDAL_LIBRARIES} ${GSL_LIBRARIES} ${ARMADILLO_LIBRARIES} )
endif(BUILD_WITH_LIBLAS)

###############################################################################

###############################################################################
# Set target properties
SET_TARGET_PROPERTIES(${PKTOOLS_BASE_LIB_NAME}
PROPERTIES
        SOVERSION ${PKTOOLS_BASE_VERSION}
        VERSION ${PKTOOLS_BASE_VERSION}
)

SET_TARGET_PROPERTIES(${PKTOOLS_IMAGECLASSES_LIB_NAME}
PROPERTIES
        SOVERSION ${PKTOOLS_IMAGECLASSES_VERSION}
        VERSION ${PKTOOLS_IMAGECLASSES_VERSION}
)

SET_TARGET_PROPERTIES(${PKTOOLS_ALGORITHMS_LIB_NAME}
PROPERTIES
        SOVERSION ${PKTOOLS_ALGORITHMS_VERSION}
        VERSION ${PKTOOLS_ALGORITHMS_VERSION}
)

SET_TARGET_PROPERTIES(${PKTOOLS_FILECLASSES_LIB_NAME}
PROPERTIES
        SOVERSION ${PKTOOLS_FILECLASSES_VERSION}
        VERSION ${PKTOOLS_FILECLASSES_VERSION}
)

if (BUILD_WITH_LIBLAS)
	SET_TARGET_PROPERTIES(${PKTOOLS_LASCLASSES_LIB_NAME}
	PROPERTIES
        SOVERSION ${PKTOOLS_LASCLASSES_VERSION}
        VERSION ${PKTOOLS_LASCLASSES_VERSION}
	)
endif(BUILD_WITH_LIBLAS)
###############################################################################

###############################################################################
# Installation 
install (TARGETS ${PKTOOLS_BASE_LIB_NAME} ${PKTOOLS_IMAGECLASSES_LIB_NAME} ${PKTOOLS_ALGORITHMS_LIB_NAME} ${PKTOOLS_FILECLASSES_LIB_NAME} DESTINATION lib)

install (FILES ${BASE_H} DESTINATION ${PROJECT_INCLUDE_DIR}/base)
install (FILES ${IMGCLASS_H} DESTINATION ${PROJECT_INCLUDE_DIR}/imageclasses)
install (FILES ${ALGOR_H} DESTINATION ${PROJECT_INCLUDE_DIR}/algorithms)
install (FILES ${FILECLASS_H} DESTINATION ${PROJECT_INCLUDE_DIR}/fileclasses)

if (BUILD_WITH_LIBLAS)
install (TARGETS ${PKTOOLS_LASCLASSES_LIB_NAME} DESTINATION lib)
install (FILES ${LASCLASS_H} DESTINATION ${PROJECT_INCLUDE_DIR}/lasclasses)
endif(BUILD_WITH_LIBLAS)
###############################################################################

=== debian/changelog ===
pktools (2.6.7-3) unstable; urgency=medium

  * Update symbols for other architectures.
  * Add patch to fix spelling errors.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 05 Nov 2016 14:22:41 +0100

pktools (2.6.7-2) unstable; urgency=medium

  * Update symbols for other architectures.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 23 May 2016 00:14:17 +0200

pktools (2.6.7-1) unstable; urgency=medium

  * Add upstream patch to fix pklas2img build failure.
  * Update symbols for arm64, hppa, hurd-i386, i386, kfreebsd-*,
    mips, mips64el, powerpc, ppc64el & s390x.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 21 May 2016 20:06:55 +0200

pktools (2.6.7-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 3.9.8, no changes.
  * Drop nlopt build dependency & configure option, support disabled upstream.
  * Update copyright file, changes:
    - Update copyright years for Pieter Kempeneers
    - Add license & copyright for QGIS plugin source
    - Drop license & copyright for Autoconf files removed upstream
    - Add license & copyright for svm.{cpp,h}
  * Switch buildsystem to CMake.
  * Enable all hardening buildflags.
  * Update manpages for upstream changes.
  * Add patch to fix SOVERSION.
  * Add library package for libbase.
  * Add patch to fix pkg-config install path.
  * Install pktools-config in dev package.
  * Add patch to fix spelling errors.
  * Add patch to build & install pklas2img.
  * Add manpage for new utilities.
  * Add symbols for libbase.
  * Disable build of pklas2img, FTBFS.
  * Add patch to not install pktools.pc as executable.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 18 May 2016 11:27:28 +0200

=== debian/control ===
Source: pktools
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Francesco Paolo Lovergine <frankie@debian.org>,
           Bas Couwenberg <sebastic@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               cmake,
               libgdal-dev (>= 1.10.0-0~),
               libgsl-dev | libgsl0-dev,
               libboost-dev,
               libarmadillo-dev,
               libfann-dev,
               liblas-c-dev (>= 1.8.0-4~),
               libsvm-dev,
               pkg-kde-tools,
               docbook2x,
               docbook-xsl,
               docbook-xml,
               xsltproc
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/pktools.git
Vcs-Git: https://anonscm.debian.org/git/pkg-grass/pktools.git
Homepage: http://pktools.nongnu.org/

Package: pktools
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Enhances: gdal-bin
Description: GDAL add-on tools to perform useful raster processing
 Pktools is a collection of programs to perform operations, mostly on
 raster geolocated  images. It  heavily relies  on the  Geospatial Data
 Abstraction Library (GDAL) and OGR.  The programs are similar to the
 GDAL tools (gdalinfo, gdal_translate,  gdal_merge, ...) and some of the
 functionalities provided in pktools already exist in the GDAL tools.
 .
 All utilities in pktools use command line options and have a built
 in help. They include more than thirty binaries to edit, change, crop,
 classify, compare, dump, fill, enhance images and many other
 common operations useful in the remote sensing field of image
 analysis.

Package: pktools-dev
Architecture: any
Section: libdevel
Depends: libalgorithms1 (= ${binary:Version}),
         libbase1 (= ${binary:Version}),
         libfileclasses1 (= ${binary:Version}),
         libimageclasses1 (= ${binary:Version}),
         liblasclasses1 (= ${binary:Version}),
         ${misc:Depends},
         libgdal-dev,
         libarmadillo-dev,
         liblas-c-dev,
         libgsl-dev | libgsl0-dev
Description: GDAL add-on tools to perform useful raster processing - development files
 Pktools is a collection of programs to perform operations, mostly on
 raster geolocated  images. It  heavily relies  on the  Geospatial Data
 Abstraction Library (GDAL) and OGR.  The programs are similar to the
 GDAL tools (gdalinfo, gdal_translate,  gdal_merge, ...) and some of the
 functionalities provided in pktools already exist in the GDAL tools.
 .
 All utilities in pktools use command line options and have a built
 in help, and include more than thirty binaries to edit, change, crop,
 classify, compare, dump, fill, enhance images and many other
 common operations useful in the remote sensing field of image
 analysis.
 .
 This package contains the files needed to develop a software that
 uses the pktools libraries.

Package: libalgorithms1
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Breaks: pktools (<< 2.5.4)
Replaces: pktools (<< 2.5.4)
Description: GDAL add-on tools to perform useful raster processing - libalgorithms
 Pktools is a collection of programs to perform operations, mostly on
 raster geolocated  images. It  heavily relies  on the  Geospatial Data
 Abstraction Library (GDAL) and OGR.  The programs are similar to the
 GDAL tools (gdalinfo, gdal_translate,  gdal_merge, ...) and some of the
 functionalities provided in pktools already exist in the GDAL tools.
 .
 All utilities in pktools use command line options and have a built
 in help, and include more than thirty binaries to edit, change, crop,
 classify, compare, dump, fill, enhance images and many other
 common operations useful in the remote sensing field of image
 analysis.
 .
 This package contains the libalgorithms shared library.

Package: libbase1
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Breaks: pktools (<< 2.5.4)
Replaces: pktools (<< 2.5.4)
Description: GDAL add-on tools to perform useful raster processing - libbase
 Pktools is a collection of programs to perform operations, mostly on
 raster geolocated  images. It  heavily relies  on the  Geospatial Data
 Abstraction Library (GDAL) and OGR.  The programs are similar to the
 GDAL tools (gdalinfo, gdal_translate,  gdal_merge, ...) and some of the
 functionalities provided in pktools already exist in the GDAL tools.
 .
 All utilities in pktools use command line options and have a built
 in help, and include more than thirty binaries to edit, change, crop,
 classify, compare, dump, fill, enhance images and many other
 common operations useful in the remote sensing field of image
 analysis.
 .
 This package contains the libbase shared library.

Package: libfileclasses1
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Breaks: pktools (<< 2.5.4)
Replaces: pktools (<< 2.5.4)
Description: GDAL add-on tools to perform useful raster processing - libfileClasses
 Pktools is a collection of programs to perform operations, mostly on
 raster geolocated  images. It  heavily relies  on the  Geospatial Data
 Abstraction Library (GDAL) and OGR.  The programs are similar to the
 GDAL tools (gdalinfo, gdal_translate,  gdal_merge, ...) and some of the
 functionalities provided in pktools already exist in the GDAL tools.
 .
 All utilities in pktools use command line options and have a built
 in help, and include more than thirty binaries to edit, change, crop,
 classify, compare, dump, fill, enhance images and many other
 common operations useful in the remote sensing field of image
 analysis.
 .
 This package contains the libfileClasses shared library.

Package: libimageclasses1
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Breaks: pktools (<< 2.5.4)
Replaces: pktools (<< 2.5.4)
Description: GDAL add-on tools to perform useful raster processing - libimageClasses
 Pktools is a collection of programs to perform operations, mostly on
 raster geolocated  images. It  heavily relies  on the  Geospatial Data
 Abstraction Library (GDAL) and OGR.  The programs are similar to the
 GDAL tools (gdalinfo, gdal_translate,  gdal_merge, ...) and some of the
 functionalities provided in pktools already exist in the GDAL tools.
 .
 All utilities in pktools use command line options and have a built
 in help, and include more than thirty binaries to edit, change, crop,
 classify, compare, dump, fill, enhance images and many other
 common operations useful in the remote sensing field of image
 analysis.
 .
 This package contains the libimageClasses shared library.

Package: liblasclasses1
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Breaks: pktools (<< 2.5.4)
Replaces: pktools (<< 2.5.4)
Description: GDAL add-on tools to perform useful raster processing - liblasClasses
 Pktools is a collection of programs to perform operations, mostly on
 raster geolocated  images. It  heavily relies  on the  Geospatial Data
 Abstraction Library (GDAL) and OGR.  The programs are similar to the
 GDAL tools (gdalinfo, gdal_translate,  gdal_merge, ...) and some of the
 functionalities provided in pktools already exist in the GDAL tools.
 .
 All utilities in pktools use command line options and have a built
 in help, and include more than thirty binaries to edit, change, crop,
 classify, compare, dump, fill, enhance images and many other
 common operations useful in the remote sensing field of image
 analysis.
 .
 This package contains the liblasClasses shared library.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

PKTOOLS_VERSION=$(shell dpkg-parsechangelog | sed -ne 's/^Version: \(.*\)-.*/\1/p' | sed -e 's/\+.*//; s/^[0-9]://')
BUILD_DATE=$(shell dpkg-parsechangelog | sed -ne 's/^Date: //p' | LC_ALL=C date -u "+%d %B %Y" -f -)

ifneq ($(wildcard /usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial/libhdf5.so),)
	export DEB_CXXFLAGS_MAINT_APPEND := -I/usr/include/hdf5/serial
endif

MANPAGES:=$(wildcard debian/man/*.*.xml)

%:
	dh $@ --buildsystem cmake \
	      --with pkgkde_symbolshelper \
	      --parallel

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_WITH_FANN=ON \
	                     -DBUILD_WITH_LIBLAS=ON \
	                     -DBUILD_SHARED_LIBS=ON

override_dh_clean:
	dh_clean debian/man/*.1
	find $(CURDIR) -name '*.o' -delete
	find $(CURDIR) -name '*.so*' -delete
	find $(CURDIR) -name '*.a' -delete

override_dh_auto_build:
	# Create man pages from DocBook XML
	for x in $(MANPAGES) ; do \
	  docbook2x-man --string-param header-3="$(BUILD_DATE)" $$x ; \
	  mv `basename $$x | sed 's/.xml$$//'` `dirname $$x` ; \
	done

	dh_auto_build

override_dh_install:
	dh_install --list-missing

override_dh_makeshlibs:
	dh_makeshlibs -- -v$(PKTOOLS_VERSION) -c0

=== debian/watch ===
version=3
opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb|\d+)\d*$//,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/ \
http://download.savannah.gnu.org/releases/pktools/ \
(?:|.*/)pktools(?:[_\-]v?|)(\d\S*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)

## pktools 2.6.7.1+ds

=== debian/changelog ===
pktools (2.6.7.1+ds-1build2) artful; urgency=medium

  * No-change rebuild for libgsl soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 06 Aug 2017 00:14:17 +0000

pktools (2.6.7.1+ds-1build1) artful; urgency=medium

  * Rebuild against new gdal ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 13 Jul 2017 13:35:44 +0200

pktools (2.6.7.1+ds-1) unstable; urgency=medium

  * New upstream release.
  * Exclude build directory and autocleaned files from upstream source.
  * Update copyright years for Pieter Kempeneers.
  * Drop patches applied upstream.
  * Bump Standards-Version to 4.0.0, no changes.
  * Add autopkgtest to test installability.
  * Use pkg-info.mk variables instead of dpkg-parsechangelog output.
  * Install pk{ann,reclass,svm}ogr in pktools package.
  * Update spelling-errors2.patch to fix new 'columns' typo.
  * Add manpages for new executables.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 29 Jun 2017 07:51:22 +0200

=== debian/control ===
--- 
+++ 
@@ -18,7 +18,7 @@
                docbook-xsl,
                docbook-xml,
                xsltproc
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/pktools.git
 Vcs-Git: https://anonscm.debian.org/git/pkg-grass/pktools.git
 Homepage: http://pktools.nongnu.org/

=== debian/rules ===
--- 
+++ 
@@ -7,8 +7,11 @@
 # Enable hardening build flags
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 
-PKTOOLS_VERSION=$(shell dpkg-parsechangelog | sed -ne 's/^Version: \(.*\)-.*/\1/p' | sed -e 's/\+.*//; s/^[0-9]://')
-BUILD_DATE=$(shell dpkg-parsechangelog | sed -ne 's/^Date: //p' | LC_ALL=C date -u "+%d %B %Y" -f -)
+include /usr/share/dpkg/pkg-info.mk
+
+UPSTREAM_VERSION = $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+.*//')
+
+BUILD_DATE=$(shell LC_ALL=C date -u "+%d %B %Y" -d "@$(SOURCE_DATE_EPOCH)")
 
 ifneq ($(wildcard /usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial/libhdf5.so),)
 	export DEB_CXXFLAGS_MAINT_APPEND := -I/usr/include/hdf5/serial
@@ -45,5 +48,5 @@
 	dh_install --list-missing
 
 override_dh_makeshlibs:
-	dh_makeshlibs -- -v$(PKTOOLS_VERSION) -c0
+	dh_makeshlibs -- -v$(UPSTREAM_VERSION) -c0

=== debian/watch ===
version=3
opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb|\d+)\d*$//,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/,\
repacksuffix=+ds \
http://download.savannah.gnu.org/releases/pktools/ \
(?:|.*/)pktools(?:[_\-]v?|)(\d\S*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)

## pktools 2.6.7.3%2Bds

=== CMakeLists.txt ===
--- 
+++ 
@@ -35,7 +35,7 @@
 # The version number.
 set (PKTOOLS_VERSION_MAJOR 2)
 set (PKTOOLS_VERSION_MINOR 6)
-set (PKTOOLS_VERSION_PATCH 7)
+set (PKTOOLS_VERSION_PATCH 7.3)
 set (PKTOOLS_VERSION "${PKTOOLS_VERSION_MAJOR}.${PKTOOLS_VERSION_MINOR}.${PKTOOLS_VERSION_PATCH}")
 set (PKTOOLS_PACKAGE_VERSION "${PKTOOLS_VERSION_MAJOR}.${PKTOOLS_VERSION_MINOR}.${PKTOOLS_VERSION_PATCH}")
 set (PKTOOLS_PACKAGE_STRING "PKTOOLS ${PKTOOLS_VERSION_MAJOR}.${PKTOOLS_VERSION_MINOR}.${PKTOOLS_VERSION_PATCH}")
@@ -43,25 +43,35 @@
 set (PKTOOLS_PACKAGE "pktools")
 set (PKTOOLS_COPYRIGHT_YEAR 2016)
 
+set (PKTOOLS_BASE_VERSION_MAJOR 1)
+set (PKTOOLS_BASE_VERSION_MINOR 6)
+set (PKTOOLS_BASE_VERSION_PATCH 1)
+set (PKTOOLS_BASE_VERSION "${PKTOOLS_BASE_VERSION_MAJOR}.${PKTOOLS_BASE_VERSION_MINOR}.${PKTOOLS_BASE_VERSION_PATCH}")
+set (PKTOOLS_BASE_SOVERSION 1)
+
 set (PKTOOLS_ALGORITHMS_VERSION_MAJOR 1)
 set (PKTOOLS_ALGORITHMS_VERSION_MINOR 6)
-set (PKTOOLS_ALGORITHMS_VERSION_PATCH 0)
+set (PKTOOLS_ALGORITHMS_VERSION_PATCH 1)
 set (PKTOOLS_ALGORITHMS_VERSION "${PKTOOLS_ALGORITHMS_VERSION_MAJOR}.${PKTOOLS_ALGORITHMS_VERSION_MINOR}.${PKTOOLS_ALGORITHMS_VERSION_PATCH}")
+set (PKTOOLS_ALGORITHMS_SOVERSION 1)
 
 set (PKTOOLS_FILECLASSES_VERSION_MAJOR 1)
 set (PKTOOLS_FILECLASSES_VERSION_MINOR 6)
-set (PKTOOLS_FILECLASSES_VERSION_PATCH 0)
+set (PKTOOLS_FILECLASSES_VERSION_PATCH 1)
 set (PKTOOLS_FILECLASSES_VERSION "${PKTOOLS_FILECLASSES_VERSION_MAJOR}.${PKTOOLS_FILECLASSES_VERSION_MINOR}.${PKTOOLS_FILECLASSES_VERSION_PATCH}")
+set (PKTOOLS_FILECLASSES_SOVERSION 1)
 
 set (PKTOOLS_IMAGECLASSES_VERSION_MAJOR 1)
 set (PKTOOLS_IMAGECLASSES_VERSION_MINOR 6)
-set (PKTOOLS_IMAGECLASSES_VERSION_PATCH 0)
+set (PKTOOLS_IMAGECLASSES_VERSION_PATCH 1)
 set (PKTOOLS_IMAGECLASSES_VERSION "${PKTOOLS_IMAGECLASSES_VERSION_MAJOR}.${PKTOOLS_IMAGECLASSES_VERSION_MINOR}.${PKTOOLS_IMAGECLASSES_VERSION_PATCH}")
+set (PKTOOLS_IMAGECLASSES_SOVERSION 1)
 
 set (PKTOOLS_LASCLASSES_VERSION_MAJOR 1)
 set (PKTOOLS_LASCLASSES_VERSION_MINOR 6)
-set (PKTOOLS_LASCLASSES_VERSION_PATCH 0)
+set (PKTOOLS_LASCLASSES_VERSION_PATCH 1)
 set (PKTOOLS_LASCLASSES_VERSION "${PKTOOLS_LASCLASSES_VERSION_MAJOR}.${PKTOOLS_LASCLASSES_VERSION_MINOR}.${PKTOOLS_LASCLASSES_VERSION_PATCH}")
+set (PKTOOLS_LASCLASSES_SOVERSION 1)
 
 # Name of C++ library
 set(PKTOOLS_BASE_LIB_NAME base)
@@ -125,7 +135,6 @@
             add_definitions(-D_CRT_NONSTDC_NO_WARNING)
             add_definitions(-D_SCL_SECURE_NO_WARNINGS)
         endif()
-        
         if(CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
             string(REGEX REPLACE "/W[0-4]" "/W4"
                    CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
@@ -210,7 +219,6 @@
 		include_directories(${Boost_INCLUDE_DIRS})
 		add_definitions("-DBOOST_ALL_NO_LIB")
 	endif()
-	
 #	include_directories(${BOOST_INCLUDE_DIR})
 #	if (MSVC)
 #		set(BOOST_LIBRARIES -LIBPATH:${BOOST_LIB_PATH} libboost_filesystem-vc100-mt-1_56.lib libboost_system-vc100-mt-1_56.lib)
@@ -253,7 +261,7 @@
 
 set_property(GLOBAL PROPERTY USE_FOLDERS ON)
 
-set(PKLIBS ${PKTOOLS_BASE_LIB_NAME} ${PKTOOLS_IMAGECLASSES_LIB_NAME} ${PKTOOLS_FILECLASSES_LIB_NAME} ${PKTOOLS_ALGORITHMS_LIB_NAME} ${GDAL_LIBRARIES} ${GSL_LIBRARIES} ${ARMADILLO_LIBRARIES} ${Boost_LIBRARIES})
+set(PKLIBS ${PKTOOLS_BASE_LIB_NAME} ${PKTOOLS_IMAGECLASSES_LIB_NAME} ${PKTOOLS_FILECLASSES_LIB_NAME} ${PKTOOLS_ALGORITHMS_LIB_NAME} ${GDAL_LIBRARIES} ${GSL_LIBRARIES} ${Boost_LIBRARIES})
 
 set(PKUTILITIES
   pkinfo
@@ -261,35 +269,42 @@
   pkdiff
   pkgetmask
   pksetmask
-  pkcreatect 
-  pkdumpimg 
-  pkdumpogr 
-  pksieve 
+  pkcreatect
+  pkdumpimg
+  pkdumpogr
+  pksieve
   pkstat
-  pkstatascii 
-  pkstatogr 
+  pkstatascii
+  pkstatogr
   pkstatprofile
-  pkegcs 
+  pkegcs
   pkextractimg
   pkextractogr
-  pkfillnodata 
-  pkfilter 
-  pkfilterdem 
-  pkfilterascii 
-  pkdsm2shadow 
+  pkfillnodata
+  pkfilter
+  pkfilterdem
+  pkfilterascii
+  pkdsm2shadow
   pkcomposite
-  pkpolygonize 
-  pkascii2img 
-  pksvm 
-  pkfssvm 
+  pkpolygonize
+  pkascii2img
+  pksvm
+  pksvmogr
+  pkfssvm
   pkoptsvm
-  pkascii2ogr 
-  pkreclass 
+  pkascii2ogr
+  pkreclass
+  pkreclassogr
   pkkalman
   )
 
+set(PKLASUTILITIES
+	pklas2img
+)
+
 set(PKFANNUTILITIES
 	pkann
+	pkannogr
 	pkfsann
 	pkregann
 )
@@ -300,28 +315,28 @@
 
 if (PKTOOLS_WITH_UTILITIES)
 	foreach(UTILITY ${PKUTILITIES})
-    		add_executable(${UTILITY} src/apps/${UTILITY}.cc)
-    		target_link_libraries(${UTILITY} ${PKLIBS})
-    		set_target_properties(${UTILITY} PROPERTIES FOLDER utilities)
+    add_executable(${UTILITY} src/apps/${UTILITY}.cc)
+    target_link_libraries(${UTILITY} ${PKLIBS})
+    set_target_properties(${UTILITY} PROPERTIES FOLDER utilities)
 	endforeach()
 
 	if (BUILD_WITH_LIBLAS)
 		set(PKLIBS ${PKLIBS} ${PKTOOLS_LASCLASSES_LIB_NAME})
 		foreach(PKLASUTILITY ${PKLASUTILITIES})
-		add_executable(${PKLASUTILITY} src/apps/${PKLASUTILITY}.cc)
-		target_link_libraries (${PKLASUTILITY} 
-		${PKLIBS} ${LIBLAS_LIBRARIES})
-    		set_target_properties(${PKLASUTILITY} PROPERTIES FOLDER utilities)
+		  add_executable(${PKLASUTILITY} src/apps/${PKLASUTILITY}.cc)
+		  target_link_libraries (${PKLASUTILITY} 
+		    ${PKLIBS} ${LIBLAS_LIBRARIES})
+    	set_target_properties(${PKLASUTILITY} PROPERTIES FOLDER utilities)
 		endforeach()
 	endif()
 	if (BUILD_WITH_FANN)
 		set(PKLIBS ${PKLIBS} ${FANN_LIBRARIES})
 		foreach(PKFANNUTILITY ${PKFANNUTILITIES})
-		add_executable(${PKFANNUTILITY} src/apps/${PKFANNUTILITY}.cc)
-		message(${PKLIBS})
-		target_link_libraries (${PKFANNUTILITY} ${PKLIBS})
-    		set_target_properties(${PKFANNUTILITY} PROPERTIES FOLDER utilities)
-		endforeach()
+		  add_executable(${PKFANNUTILITY} src/apps/${PKFANNUTILITY}.cc)
+		  # message(${PKLIBS})
+		  target_link_libraries (${PKFANNUTILITY} ${PKLIBS})
+      set_target_properties(${PKFANNUTILITY} PROPERTIES FOLDER utilities)
+	  endforeach()
 	endif()
 	# if (BUILD_WITH_NLOPT)
 	# 	set(PKLIBS ${PKLIBS} ${NLOPT_LIBRARIES})
@@ -330,16 +345,3 @@
 	# 	message(${PKLIBS})
 	# 	target_link_libraries (${PKNLOPTUTILITY} ${PKLIBS})
     	# 	set_target_properties(${PKNLOPTUTILITY} PROPERTIES FOLDER utilities)
-	# 	endforeach()
-	# endif()	
-	# add_custom_target(utilities DEPENDS ${PKUTILITIES} ${PKLASUTILITIES} ${PKFANNUTILITIES} ${PKNLOPTUTILITIES})
-	add_custom_target(utilities DEPENDS ${PKUTILITIES} ${PKLASUTILITIES} ${PKFANNUTILITIES})
-	set_target_properties(utilities PROPERTIES FOLDER 
-	phony)
-
-endif()
-
-
-	
-###############################################################################
-
